#include <chrono>
#include <iostream>
#include <thread>
#include <vector>

using namespace std;
using namespace std::chrono;

void doJob(int id) {
    this_thread::sleep_for(chrono::seconds((6 * id + 3) % 5));
    cout << "The job " << id << " has been completed!" << endl;
}

int main() {
    vector<thread> workers;
    int numOfWorkers = thread::hardware_concurrency();
    for (int jobId = 0; jobId < numOfWorkers; ++jobId) {
        workers.push_back(thread(doJob, jobId));
    }

    for (auto &worker : workers) {
        worker.join();
    }

    cout << "Main thread completing..." << endl;

    return 0;
}